SqlUtil::Constraints Class Reference

constraint container class that throws an exception if an unknown constraint is accessed More...

Inheritance diagram for SqlUtil::Constraints:
[legend]

## Public Member Functions

| add (string k, AbstractConstraint val)
| adds the given value to the hash with the given key name
*AbstractUniqueConstraint | findEqualUniqueConstraint (AbstractUniqueConstraint uk)
| finds a unique constraint with the same columns as the unique constraint passed
string | getElementName ()
| must return the name of the contained element
AbstractConstraint | memberGate (string k)
| returns the AbstractConstraint object corresponding to the key given or throws a KEY-ERROR exception More...
AbstractConstraint | take (string k)
| removes the given key from the contained hash and returns the value
Public Member Functions inherited from SqlUtil::AbstractHashContainer
| clear ()
| purges the contained data More...
| constructor (*hash nh)
| creates the object with the hash argument passed
| constructor (AbstractHashContainer old)
| creates a copy of the object
| copy (AbstractHashContainer old)
| creates a "deep copy" of the object
bool | empty ()
| returns True if the container is empty, False if not
*string | firstKey ()
| Returns the first key name in the contained hash or NOTHING if the contained hash has no keys. More...
*hash | getHash ()
| returns the hash contained by this object
bool | hasKey (string k)
| Returns True if the key exists in the contained hash (may or may not be assigned a value), False if not. More...
bool | hasKeyValue (string k)
| Returns True if the key exists in the contained hash and is assigned a value, False if not. More...
Qore::AbstractIterator | iterator ()
| Returns a HashIterator object for the contained hash. More...
Qore::AbstractIterator | keyIterator ()
| Returns a HashKeyIterator object for the contained hash. More...
list< string > | keys ()
| Returns a list of key names of the contained hash. More...
*string | lastKey ()
| Returns the last key name in the contained hash or NOTHING if the contained hash has no keys. More...
bool | matchKeys (hash h1)
| returns True if the hash argument has the same keys (in any order), False if not More...
bool | matchKeys (list l)
| returns True if the list argument has the same list of key strings as the keys in the object (in any order), False if not More...
bool | matchKeys (AbstractHashContainer c)
| returns True if the container argument has the same keys (in any order), False if not More...
auto | memberGate (string k)
| returns the value of the given key in the contained hash if it exists, otherwise throws a `KEY-ERROR` exception More...
Qore::AbstractIterator | pairIterator ()
| Returns a HashPairIterator object for the contained hash. More...
bool | partialMatchKeys (hash h1)
| returns True if the hash argument has at least the same keys (in any order, can have more keys), False if not More...
bool | partialMatchKeys (list l)
| returns True if the list argument has at least the same keys (in any order, can have more keys), False if not More...
bool | partialMatchKeys (AbstractHashContainer c)
| returns True if the container argument has at least the same keys (in any order, can have more keys), False if not More...
| renameKey (string old_name, string new_name)
| renames the given key; maintains the key order
int | size ()
| Returns the number of keys in the contained hash. More...
bool | val ()
| Returns False if the contained hash has no keys, True if it does. More...
list | values ()
| Returns a list of values of the contained hash. More...

## Detailed Description

constraint container class that throws an exception if an unknown constraint is accessed

## Member Function Documentation

## memberGate()

AbstractConstraint SqlUtil::Constraints::memberGate | ( | string | k | ) |

returns the AbstractConstraint object corresponding to the key given or throws a KEY-ERROR exception

Example:
  AbstractConstraint ix = constraints.uk_jobs;

Parameters

  k | the name of the key to access

Returns
  the value of the given key in the contained hash if it exists

Exceptions

  KEY-ERROR | the given key does not exist in the contained hash

Note
  this method is called automatically when an unknown or inaccessible member name is accessed from outside the class

See also
  memberGate_methods